# dartlin
[![coverage report](https://gitlab.com/wolfenrain/dartlin/badges/master/coverage.svg)](https://gitlab.com/wolfenrain/dartlin/-/commits/master)
[![pipeline status](https://gitlab.com/wolfenrain/dartlin/badges/master/pipeline.svg)](https://gitlab.com/wolfenrain/dartlin/-/commits/master)  
[![plugin version](https://img.shields.io/pub/v/dartlin?label=pub)](https://pub.dev/packages/dartlin)
[![dependencies](https://img.shields.io/librariesio/release/pub/dartlin?label=dependencies)](https://gitlab.com/wolfenrain/dartlin/-/blob/master/pubspec.yaml)

## Introduction

### What it does

Dartlin is a helper library that provides readable methods with which you can write cleaner looking code. 
- It allows you to have more control over your code flow. By using the `when` method for example, to write switch-like expressions.
- It provides methods to create data sets of certain types, for example the `range` method.

## What does it not do

The main focus of the library is adding readable methods and readability tends to not equal performance optimization. So is the case for some of the provided methods in this library. The performance hits of these methods is very minimal, but most of them do rely on [closures](https://dart.dev/guides/language/language-tour#anonymous-functions) to work.

## Common Usage

### Control flow

The `when` method replaces the switch statement. And can be used to write expressions:
```dart
final result = when(place, {
  1: () => CompetitionPlace.first,
  2: () => CompetitionPlace.second,
  3: () => CompetitionPlace.third,
  [4,5]: () => CompetitionPlace.honourableMentions,
  orElse: () => CompetitionPlace.others
});
```
See the [when](https://pub.dev/documentation/dartlin/latest/control_flow/when.html) docs for more information.
